#ifndef _ASM_SW_64_SYSCALL_H
#define _ASM_SW_64_SYSCALL_H

#include <uapi/linux/audit.h>

static inline int syscall_get_arch(void)
{
    return AUDIT_ARCH_SW_64;
}

static inline void syscall_rollback(struct task_struct *task,
                                    struct pt_regs *regs)
{
}

static inline void syscall_set_return_value(struct task_struct *task,
					    struct pt_regs *regs,
					    int error, long val)
{
	regs->r0 = (long) error ?: val;
}

static inline void syscall_get_arguments(struct task_struct *task,
                                         struct pt_regs *regs,
                                         unsigned int i, unsigned int n,
                                         unsigned long *args)
{
    unsigned long v = 0;
	BUG_ON(i + n > 6);
    for (; i < n; i++) {
        switch (i) {
        case 0:
            v = regs->r16; break;
        case 1:
            v = regs->r17; break;
        case 2:
            v = regs->r18; break;
        case 3:
            v = regs->r19; break;
        case 4:
            v = regs->r20; break;
        case 5:
            v = regs->r21; break;
        default:
            BUG();
            break;
        }
        *(args+i) = v;
    }
}


static inline long syscall_get_nr(struct task_struct *task,
                                  struct pt_regs *regs)
{
    return regs->r0;
}

#endif  /* _ASM_SW_64_SYSCALL_H */
